/*
 * tardy - a tar post-processor
 * Copyright (C) 1993-2000, 2003, 2004, 2008, 2009, 2011 Peter Miller
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

configuration_directory = "aegis.conf.d";

/*
 * how to build the project
 * mandatory
 */
build_command =
    "cook -b ${source etc/howto.cook} "
    "-nl -st "
    "project=$project "
    "change=$change "
    "version=$version "
    "arch=$arch "
    "search_path=$search_path";

/*
 * When do -Integrate_Begin, link the baseline to the integration directory,
 * rather than copying it.  This should be much faster.
 *
 * There is a gotcha: all the recipes in howto.cook must unlink their targets
 * before re-creating them, otherwise the baseline will be trashed.
 */
link_integration_directory = true;

/*
 * create a new history
 * always executed as the project owner
 */
history_create_command =
    "fhist ${b $history} -cr -cu -i $input -p ${d $history} -r";

/*
 * get a file from history
 * may be executed by developers
 */
history_get_command =
    "fhist ${b $history} -e '$edit' -o $output -p ${d $history} -v 0";

/*
 * add a new change to the history
 * always executed as the project owner
 */
history_put_command =
    "fhist ${b $history} -cr -cu -i $input -p ${d $history} -r";

/*
 * query the topmost edit of a history file
 * Result to be printed on stdout.
 * may be executed by developers
 */
history_query_command =
    "fhist ${basename $history} -l 0 -p ${dirname $history} -q";

/*
 * difference of 2 files
 */
diff_command = "fcomp -w -s $original $input -o $output";

/*
 * difference of 3 files
 */
merge_command = "fmerge $original $mostrecent $input -o $output -c /dev/null";

/*
 * whenever files are added to or removed from the change,
 * execute the following command.
 */
change_file_command = "rm -f .c_inclrc";

/*
 * new file templates
 */
file_template =
[
    {
        pattern = [ "*.[cyl]", "*.cc" ];
        body = "${read_file ${source etc/template/c abs}}";
    },
    {
        pattern = [ "libtardy/ac/*.h" ];
        body = "${read_file ${source etc/template/ac_h abs}}";
    },
    {
        pattern = [ "*.h" ];
        body = "${read_file ${source etc/template/h abs}}";
    },
    {
        pattern = [ "test/*/*.sh" ];
        body = "${read_file ${source etc/template/test abs}}";
    },
    {
        pattern = [ "*.sh" ];
        body = "${read_file ${source etc/template/sh abs}}";
    },
    {
        pattern = [ "*.man", "*.[12345678]" ];
        body = "${read_file ${source etc/template/man abs}}";
    },
    {
        pattern = [ "etc/new*.so" ];
        body = "${read_file ${source etc/template/etc_so abs}}";
    },
    {
        pattern = [ "*.so", "*.ms", "*.me" ];
        body = "${read_file ${source etc/template/ms abs}}";
    },
    {
        pattern = [ "*" ];
        body = "${read_file ${source etc/template/generic abs}}";
    }
];

develop_begin_command = "ln -s $bl bl";
integrate_begin_command =
    "rm -f aegis.log etc/version.so common/patchlevel.h etc/new.so";

/*
 * list of architectures on which each change must build and test
 */
architecture =
[
    {
        name = "linux-x86_64";
        pattern = "Linux-*-*-*86_64";
    },
];

/*
 * Some file names which are not allowed...
 */
filename_pattern_reject =
[
    "*.c",  /* no plain C files */
    "*.C",  /* short, but not unique on some operating systems */
    "*.[cC]++",     /* not legal on some operating systems */
];

test_command =
    "PATH=${path_reduce ${addpathsuffix ${arch}/bin ${spe}} ${env PATH}} "
    "$sh $filename $arch"
    ;

project_specific =
[
    {
        name = "html:body-begin";
        value = @<a href="http://tardy.sourceforge.net/"><img
        src="http://tardy.sourceforge.net/tardy.png" align=left
        border=0></a><a href="http://tardy.sourceforge.net/"><img
        src="http://tardy.sourceforge.net/tardy.png" align=right
        border=0></a>@;
    }
];
